/*
  CRF++ -- Yet Another CRF toolkit

  $Id: feature_cache.cpp,v 1.7 2006/08/07 02:35:35 taku Exp $;

  Copyright(C) 2005 Taku Kudo <taku@chasen.org>

  This is free software with ABSOLUTELY NO WARRANTY.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or(at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "feature_cache.h"
#include <algorithm>

namespace CRFPP {

  void FeatureCache::add(const std::vector<int> &f)
  {
    int *p = feature_freelist_.alloc(f.size() + 1);
    std::copy(f.begin(), f.end(), p);
    p[f.size()] = -1; // sentinel
    this->push_back(p);
  }

  void FeatureCache::shrink(std::map<int,int> &old2new)
  {
    for (size_t i = 0; i < size(); ++i) {
      std::vector<int> newf;
      for (int *f = (*this)[i]; *f != -1; ++f) {
        std::map<int,int>::iterator it = old2new.find(*f);
        if (it != old2new.end()) newf.push_back(it->second);
      }
      newf.push_back(-1);
      std::copy(newf.begin(), newf.end(),(*this)[i]);
    }
    return;
  }
}
