/*
  CRF++ -- Yet Another CRF toolkit

  $Id: feature_cache.h,v 1.10 2006/08/07 02:35:35 taku Exp $;

  Copyright(C) 2005 Taku Kudo <taku@chasen.org>

  This is free software with ABSOLUTELY NO WARRANTY.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or(at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _CRFPP_FEATURE_CACHE_H
#define _CRFPP_FEATURE_CACHE_H

#include <vector>
#include <map>
#include "freelist.h"

namespace CRFPP {

  class FeatureCache: public std::vector <int *> {
  private:
    FreeList<int> feature_freelist_;

  public:
    void clear() {
      std::vector<int *>::clear();
      feature_freelist_.free();
    }

    void add(const std::vector<int> &);
    void shrink(std::map<int,int> &);

    explicit FeatureCache(): feature_freelist_(8192 * 16) {};
    virtual ~FeatureCache() {};
  };
}
#endif
