/*
  CRF++ -- Yet Another CRF toolkit

  $Id: path.cpp,v 1.6 2006/08/07 02:35:35 taku Exp $;

  Copyright(C) 2005 Taku Kudo <taku@chasen.org>

  This is free software with ABSOLUTELY NO WARRANTY.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or(at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "path.h"
#include "common.h"
#include <cmath>

namespace CRFPP {

  void Path::calcExpectation(double *expected, double Z, size_t size)
  {
    double c = std::exp(lnode->alpha + cost + rnode->beta - Z);
    for (int *f = fvector; *f != -1; ++f) expected[*f + lnode->y * size + rnode->y] += c;
  }

  void Path::add(Node *_lnode, Node *_rnode)
  {
    lnode = _lnode;
    rnode = _rnode;
    lnode->rpath.push_back(this);
    rnode->lpath.push_back(this);
  }
}
