/*
  CRF++ -- Yet Another CRF toolkit

  $Id: path.h,v 1.7 2006/08/07 02:35:35 taku Exp $;

  Copyright(C) 2005 Taku Kudo <taku@chasen.org>

  This is free software with ABSOLUTELY NO WARRANTY.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or(at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _CRFPP_PATH_H
#define _CRFPP_PATH_H

#include "node.h"
#include <vector>

namespace CRFPP
{
  struct Node;

  struct Path
  {
    Node *rnode;
    Node *lnode;
    int *fvector;
    double cost;

    Path(): rnode(0), lnode(0), fvector(0), cost(0.0) {};

    // for CRF
    void calcExpectation(double *expected, double, size_t);
    void add(Node *_lnode, Node *_rnode) ;

    void clear()
    {
      rnode = lnode = 0;
      fvector = 0;
      cost = 0.0;
    }
  };

  typedef std::vector<Path*>::iterator Path_iterator;
}

#endif
